Attribute VB_Name = "modCode"
Option Explicit

Private Type RECT
   Left As Long
   Top As Long
   Right As Long
   Bottom As Long
End Type

Declare Function GetClientRect Lib "user32" (ByVal hwnd As Long, lpRect As RECT) As Long
Declare Function GetWindowLong Lib "user32" Alias "GetWindowLongA" (ByVal hwnd As Long, ByVal nIndex As Long) As Long
Declare Sub SetWindowPos Lib "user32" (ByVal hwnd As Long, ByVal hWndInsertAfter As Long, ByVal X As Long, ByVal Y As Long, ByVal cx As Long, ByVal cy As Long, ByVal wFlags As Long)
Declare Function SetWindowLong Lib "user32" Alias "SetWindowLongA" (ByVal hwnd As Long, ByVal nIndex As Long, ByVal dwNewLong As Long) As Long
Declare Function SetParent Lib "user32" (ByVal hWndChild As Long, ByVal hWndNewParent As Long) As Long
Declare Function ShowCursor Lib "user32" (ByVal bShow As Long) As Long

Public intHue As Integer
Public intFixedHue As Integer
Public intCircleX(0 To 23) As Integer
Public intCircleY(0 To 23) As Integer
Public intRadius As Integer
Public blnPreview As Boolean
Public blnCycle As Boolean
Public blnTime24h As Boolean

Private Const WS_CHILD = &H40000000
Private Const GWL_STYLE = (-16)
Private Const GWL_HWNDPARENT = (-8)
Private Const HWND_TOP = 0&
Private Const SWP_NOZORDER = &H4
Private Const SWP_NOACTIVATE = &H10
Private Const SWP_SHOWWINDOW = &H40

Sub Main()
    blnCycle = GetSetting("Paul248", "BinaryClock", "Cycle", True)
    intFixedHue = GetSetting("Paul248", "BinaryClock", "Hue", 180)
    blnTime24h = GetSetting("Paul248", "BinaryClock", "24h Time", True)
    
    Randomize
    intHue = Int(Rnd * 360)
    
    Select Case LCase(Left(Command, 2))
        Case "/c"
            frmConfig.Show 1
            End
        Case "/p"
            blnPreview = True
            DoPreviewMode frmMain
        Case "/a"
            End
        Case Else
            ShowCursor False
    End Select
    
    If Not blnCycle Then intHue = intFixedHue

    frmMain.Show
    FindCircleXY frmMain.ScaleWidth, frmMain.ScaleHeight
    frmMain.UpdateTime
End Sub

Sub FindCircleXY(intWidth As Integer, intHeight As Integer)
    Dim sngMargin As Single
    Dim sngPosX As Single
    Dim sngPosY As Single
    Dim sngRadius As Single
    Dim X As Integer
    Dim Y As Integer
    Dim b As Integer
    
    sngMargin = intWidth / 127
    sngRadius = intWidth / 12.7
    intRadius = Int(sngRadius)
    sngPosY = (intHeight / 2) - (sngRadius * 2 + sngMargin)
    b = 0
    For Y = 0 To 2
        sngPosX = sngMargin + sngRadius
        For X = 0 To 5
            intCircleX(b) = sngPosX
            intCircleY(b) = sngPosY
            b = b + 1
            sngPosX = sngPosX + sngRadius * 2 + sngMargin
        Next X
        sngPosY = sngPosY + sngRadius * 2 + sngMargin
    Next Y
End Sub

Function HSBToRGB(H As Integer, S As Integer, L As Integer) As Long
    Dim R As Integer, G As Integer, b As Integer
    Dim nH As Single, nS As Single, nL As Single
    Dim nF As Single, nP As Single, nQ As Single, nT As Single
    Dim iH As Integer

    If S > 0 Then
  
        nH = H / 60: nL = L / 255: nS = S / 255
        
        iH = Int(nH)
        nF = nH - iH
        nP = nL * (1 - nS)
        nQ = nL * (1 - nS * nF)
        nT = nL * (1 - nS * (1 - nF))
        Select Case iH
        Case 0
            R = nL * 255
            G = nT * 255
            b = nP * 255
        Case 1
            R = nQ * 255
            G = nL * 255
            b = nP * 255
        Case 2
            R = nP * 255
            G = nL * 255
            b = nT * 255
        Case 3
            R = nP * 255
            G = nQ * 255
            b = nL * 255
        Case 4
            R = nT * 255
            G = nP * 255
            b = nL * 255
        Case 5
            R = nL * 255
            G = nP * 255
            b = nQ * 255
        End Select
    Else
        R = (L * 255) / 100
        G = R: b = R
    End If
  
    HSBToRGB = RGB(R, G, b)
End Function

Function GetCol(intBit As Integer, intBright As Integer) As Long
    If intBit = 0 Then
        If intBright > 192 Then
            GetCol = &H404040
        Else
            GetCol = &H202020
        End If
        Exit Function
    End If
        
    GetCol = HSBToRGB(intHue, 255, intBright)
End Function

Public Sub DoPreviewMode(PreviewForm As Form)
    Dim lngStyle As Long, dispHWND As Long, DispRec As RECT
    dispHWND = CLng(Mid(Command, 4))
    Load PreviewForm
    GetClientRect dispHWND, DispRec
    lngStyle = GetWindowLong(PreviewForm.hwnd, GWL_STYLE)
    lngStyle = lngStyle Or WS_CHILD ' Append "WS_CHILD"
    SetWindowLong PreviewForm.hwnd, GWL_STYLE, lngStyle
    SetParent PreviewForm.hwnd, dispHWND
    SetWindowLong PreviewForm.hwnd, GWL_HWNDPARENT, dispHWND
    SetWindowPos PreviewForm.hwnd, HWND_TOP, 0&, 0&, DispRec.Right, DispRec.Bottom, SWP_NOZORDER Or SWP_NOACTIVATE Or SWP_SHOWWINDOW
End Sub

